    0  $accept : programa $end

    1  programa : sentencia
    2           | programa sentencia

    3  sentencia : ID '=' expresion ';'
    4            | expresion ';'
    5            | s_if
    6            | s_while
    7            | '{' lista_sentencias '}'
    8            | ID '=' KW_READ '(' ')' ';'
    9            | KW_WRITE '(' expresion ')' ';'
   10            | KW_WRITE '(' STRING ')' ';'
   11            | KW_NEWLINE '(' ')' ';'
   12            | declaracion ';'

   13  lista_sentencias : sentencia
   14                   | lista_sentencias sentencia

   15  declaracion : KW_INT ID
   16              | declaracion ',' ID

   17  s_if : KW_IF '(' condicion ')' sentencia
   18       | KW_IF '(' condicion ')' sentencia KW_ELSE sentencia

   19  s_while : KW_WHILE '(' condicion ')' sentencia

   20  condicion : expresion COMP expresion
   21            | condicion '|' condicion
   22            | condicion '&' condicion

   23  expresion : expresion '+' expresion
   24            | expresion '-' expresion
   25            | expresion '*' expresion
   26            | expresion '/' expresion
   27            | '-' expresion
   28            | '(' expresion ')'
   29            | ID
   30            | CONS


state 0
	$accept : . programa $end

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	programa goto 11
	sentencia goto 12
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 1
	expresion : '(' . expresion ')'

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 18


state 2
	expresion : '-' . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 19


state 3
	sentencia : '{' . lista_sentencias '}'

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 20
	lista_sentencias goto 21
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 4
	s_if : KW_IF . '(' condicion ')' sentencia
	s_if : KW_IF . '(' condicion ')' sentencia KW_ELSE sentencia

	'('  shift 22


state 5
	s_while : KW_WHILE . '(' condicion ')' sentencia

	'('  shift 23


state 6
	declaracion : KW_INT . ID

	ID  shift 24


state 7
	sentencia : KW_WRITE . '(' expresion ')' ';'
	sentencia : KW_WRITE . '(' STRING ')' ';'

	'('  shift 25


state 8
	sentencia : KW_NEWLINE . '(' ')' ';'

	'('  shift 26


state 9
	sentencia : ID . '=' expresion ';'
	sentencia : ID . '=' KW_READ '(' ')' ';'
	expresion : ID .  (29)

	'='  shift 27
	'*'  reduce 29
	'+'  reduce 29
	'-'  reduce 29
	'/'  reduce 29
	';'  reduce 29


state 10
	expresion : CONS .  (30)

	'&'  reduce 30
	')'  reduce 30
	'*'  reduce 30
	'+'  reduce 30
	'-'  reduce 30
	'/'  reduce 30
	';'  reduce 30
	'|'  reduce 30
	COMP  reduce 30


state 11
	$accept : programa . $end  (0)
	programa : programa . sentencia

	$end  accept
	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 28
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 12
	programa : sentencia .  (1)

	$end  reduce 1
	'('  reduce 1
	'-'  reduce 1
	'{'  reduce 1
	KW_IF  reduce 1
	KW_WHILE  reduce 1
	KW_INT  reduce 1
	KW_WRITE  reduce 1
	KW_NEWLINE  reduce 1
	ID  reduce 1
	CONS  reduce 1


state 13
	sentencia : s_if .  (5)

	$end  reduce 5
	'('  reduce 5
	'-'  reduce 5
	'{'  reduce 5
	'}'  reduce 5
	KW_IF  reduce 5
	KW_ELSE  reduce 5
	KW_WHILE  reduce 5
	KW_INT  reduce 5
	KW_WRITE  reduce 5
	KW_NEWLINE  reduce 5
	ID  reduce 5
	CONS  reduce 5


state 14
	sentencia : s_while .  (6)

	$end  reduce 6
	'('  reduce 6
	'-'  reduce 6
	'{'  reduce 6
	'}'  reduce 6
	KW_IF  reduce 6
	KW_ELSE  reduce 6
	KW_WHILE  reduce 6
	KW_INT  reduce 6
	KW_WRITE  reduce 6
	KW_NEWLINE  reduce 6
	ID  reduce 6
	CONS  reduce 6


state 15
	sentencia : expresion . ';'
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32
	';'  shift 33


state 16
	sentencia : declaracion . ';'
	declaracion : declaracion . ',' ID

	','  shift 34
	';'  shift 35


state 17
	expresion : ID .  (29)

	'&'  reduce 29
	')'  reduce 29
	'*'  reduce 29
	'+'  reduce 29
	'-'  reduce 29
	'/'  reduce 29
	';'  reduce 29
	'|'  reduce 29
	COMP  reduce 29


state 18
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion
	expresion : '(' expresion . ')'

	')'  shift 36
	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32


state 19
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion
	expresion : '-' expresion .  (27)

	'&'  reduce 27
	')'  reduce 27
	'*'  reduce 27
	'+'  reduce 27
	'-'  reduce 27
	'/'  reduce 27
	';'  reduce 27
	'|'  reduce 27
	COMP  reduce 27


state 20
	lista_sentencias : sentencia .  (13)

	'('  reduce 13
	'-'  reduce 13
	'{'  reduce 13
	'}'  reduce 13
	KW_IF  reduce 13
	KW_WHILE  reduce 13
	KW_INT  reduce 13
	KW_WRITE  reduce 13
	KW_NEWLINE  reduce 13
	ID  reduce 13
	CONS  reduce 13


state 21
	sentencia : '{' lista_sentencias . '}'
	lista_sentencias : lista_sentencias . sentencia

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	'}'  shift 37
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 38
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 22
	s_if : KW_IF '(' . condicion ')' sentencia
	s_if : KW_IF '(' . condicion ')' sentencia KW_ELSE sentencia

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 39
	condicion goto 40


state 23
	s_while : KW_WHILE '(' . condicion ')' sentencia

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 39
	condicion goto 41


state 24
	declaracion : KW_INT ID .  (15)

	','  reduce 15
	';'  reduce 15


state 25
	sentencia : KW_WRITE '(' . expresion ')' ';'
	sentencia : KW_WRITE '(' . STRING ')' ';'

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10
	STRING  shift 42

	expresion goto 43


state 26
	sentencia : KW_NEWLINE '(' . ')' ';'

	')'  shift 44


state 27
	sentencia : ID '=' . expresion ';'
	sentencia : ID '=' . KW_READ '(' ')' ';'

	'('  shift 1
	'-'  shift 2
	KW_READ  shift 45
	ID  shift 17
	CONS  shift 10

	expresion goto 46


state 28
	programa : programa sentencia .  (2)

	$end  reduce 2
	'('  reduce 2
	'-'  reduce 2
	'{'  reduce 2
	KW_IF  reduce 2
	KW_WHILE  reduce 2
	KW_INT  reduce 2
	KW_WRITE  reduce 2
	KW_NEWLINE  reduce 2
	ID  reduce 2
	CONS  reduce 2


state 29
	expresion : expresion '*' . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 47


state 30
	expresion : expresion '+' . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 48


state 31
	expresion : expresion '-' . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 49


state 32
	expresion : expresion '/' . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 50


state 33
	sentencia : expresion ';' .  (4)

	$end  reduce 4
	'('  reduce 4
	'-'  reduce 4
	'{'  reduce 4
	'}'  reduce 4
	KW_IF  reduce 4
	KW_ELSE  reduce 4
	KW_WHILE  reduce 4
	KW_INT  reduce 4
	KW_WRITE  reduce 4
	KW_NEWLINE  reduce 4
	ID  reduce 4
	CONS  reduce 4


state 34
	declaracion : declaracion ',' . ID

	ID  shift 51


state 35
	sentencia : declaracion ';' .  (12)

	$end  reduce 12
	'('  reduce 12
	'-'  reduce 12
	'{'  reduce 12
	'}'  reduce 12
	KW_IF  reduce 12
	KW_ELSE  reduce 12
	KW_WHILE  reduce 12
	KW_INT  reduce 12
	KW_WRITE  reduce 12
	KW_NEWLINE  reduce 12
	ID  reduce 12
	CONS  reduce 12


state 36
	expresion : '(' expresion ')' .  (28)

	'&'  reduce 28
	')'  reduce 28
	'*'  reduce 28
	'+'  reduce 28
	'-'  reduce 28
	'/'  reduce 28
	';'  reduce 28
	'|'  reduce 28
	COMP  reduce 28


state 37
	sentencia : '{' lista_sentencias '}' .  (7)

	$end  reduce 7
	'('  reduce 7
	'-'  reduce 7
	'{'  reduce 7
	'}'  reduce 7
	KW_IF  reduce 7
	KW_ELSE  reduce 7
	KW_WHILE  reduce 7
	KW_INT  reduce 7
	KW_WRITE  reduce 7
	KW_NEWLINE  reduce 7
	ID  reduce 7
	CONS  reduce 7


state 38
	lista_sentencias : lista_sentencias sentencia .  (14)

	'('  reduce 14
	'-'  reduce 14
	'{'  reduce 14
	'}'  reduce 14
	KW_IF  reduce 14
	KW_WHILE  reduce 14
	KW_INT  reduce 14
	KW_WRITE  reduce 14
	KW_NEWLINE  reduce 14
	ID  reduce 14
	CONS  reduce 14


state 39
	condicion : expresion . COMP expresion
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32
	COMP  shift 52


state 40
	s_if : KW_IF '(' condicion . ')' sentencia
	s_if : KW_IF '(' condicion . ')' sentencia KW_ELSE sentencia
	condicion : condicion . '|' condicion
	condicion : condicion . '&' condicion

	'&'  shift 53
	')'  shift 54
	'|'  shift 55


state 41
	s_while : KW_WHILE '(' condicion . ')' sentencia
	condicion : condicion . '|' condicion
	condicion : condicion . '&' condicion

	'&'  shift 53
	')'  shift 56
	'|'  shift 55


state 42
	sentencia : KW_WRITE '(' STRING . ')' ';'

	')'  shift 57


state 43
	sentencia : KW_WRITE '(' expresion . ')' ';'
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	')'  shift 58
	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32


state 44
	sentencia : KW_NEWLINE '(' ')' . ';'

	';'  shift 59


state 45
	sentencia : ID '=' KW_READ . '(' ')' ';'

	'('  shift 60


state 46
	sentencia : ID '=' expresion . ';'
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32
	';'  shift 61


state 47
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion '*' expresion .  (25)
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'&'  reduce 25
	')'  reduce 25
	'*'  reduce 25
	'+'  reduce 25
	'-'  reduce 25
	'/'  reduce 25
	';'  reduce 25
	'|'  reduce 25
	COMP  reduce 25


state 48
	expresion : expresion '+' expresion .  (23)
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'/'  shift 32
	'&'  reduce 23
	')'  reduce 23
	'+'  reduce 23
	'-'  reduce 23
	';'  reduce 23
	'|'  reduce 23
	COMP  reduce 23


state 49
	expresion : expresion . '+' expresion
	expresion : expresion '-' expresion .  (24)
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'/'  shift 32
	'&'  reduce 24
	')'  reduce 24
	'+'  reduce 24
	'-'  reduce 24
	';'  reduce 24
	'|'  reduce 24
	COMP  reduce 24


state 50
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion '/' expresion .  (26)
	expresion : expresion . '/' expresion

	'&'  reduce 26
	')'  reduce 26
	'*'  reduce 26
	'+'  reduce 26
	'-'  reduce 26
	'/'  reduce 26
	';'  reduce 26
	'|'  reduce 26
	COMP  reduce 26


state 51
	declaracion : declaracion ',' ID .  (16)

	','  reduce 16
	';'  reduce 16


state 52
	condicion : expresion COMP . expresion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 62


state 53
	condicion : condicion '&' . condicion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 39
	condicion goto 63


state 54
	s_if : KW_IF '(' condicion ')' . sentencia
	s_if : KW_IF '(' condicion ')' . sentencia KW_ELSE sentencia

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 64
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 55
	condicion : condicion '|' . condicion

	'('  shift 1
	'-'  shift 2
	ID  shift 17
	CONS  shift 10

	expresion goto 39
	condicion goto 65


state 56
	s_while : KW_WHILE '(' condicion ')' . sentencia

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 66
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 57
	sentencia : KW_WRITE '(' STRING ')' . ';'

	';'  shift 67


state 58
	sentencia : KW_WRITE '(' expresion ')' . ';'

	';'  shift 68


state 59
	sentencia : KW_NEWLINE '(' ')' ';' .  (11)

	$end  reduce 11
	'('  reduce 11
	'-'  reduce 11
	'{'  reduce 11
	'}'  reduce 11
	KW_IF  reduce 11
	KW_ELSE  reduce 11
	KW_WHILE  reduce 11
	KW_INT  reduce 11
	KW_WRITE  reduce 11
	KW_NEWLINE  reduce 11
	ID  reduce 11
	CONS  reduce 11


state 60
	sentencia : ID '=' KW_READ '(' . ')' ';'

	')'  shift 69


state 61
	sentencia : ID '=' expresion ';' .  (3)

	$end  reduce 3
	'('  reduce 3
	'-'  reduce 3
	'{'  reduce 3
	'}'  reduce 3
	KW_IF  reduce 3
	KW_ELSE  reduce 3
	KW_WHILE  reduce 3
	KW_INT  reduce 3
	KW_WRITE  reduce 3
	KW_NEWLINE  reduce 3
	ID  reduce 3
	CONS  reduce 3


state 62
	condicion : expresion COMP expresion .  (20)
	expresion : expresion . '+' expresion
	expresion : expresion . '-' expresion
	expresion : expresion . '*' expresion
	expresion : expresion . '/' expresion

	'*'  shift 29
	'+'  shift 30
	'-'  shift 31
	'/'  shift 32
	'&'  reduce 20
	')'  reduce 20
	'|'  reduce 20


state 63
	condicion : condicion . '|' condicion
	condicion : condicion '&' condicion .  (22)
	condicion : condicion . '&' condicion

	'&'  reduce 22
	')'  reduce 22
	'|'  reduce 22


state 64
	s_if : KW_IF '(' condicion ')' sentencia .  (17)
	s_if : KW_IF '(' condicion ')' sentencia . KW_ELSE sentencia

	KW_ELSE  shift 70
	$end  reduce 17
	'('  reduce 17
	'-'  reduce 17
	'{'  reduce 17
	'}'  reduce 17
	KW_IF  reduce 17
	KW_WHILE  reduce 17
	KW_INT  reduce 17
	KW_WRITE  reduce 17
	KW_NEWLINE  reduce 17
	ID  reduce 17
	CONS  reduce 17


state 65
	condicion : condicion '|' condicion .  (21)
	condicion : condicion . '|' condicion
	condicion : condicion . '&' condicion

	'&'  reduce 21
	')'  reduce 21
	'|'  reduce 21


state 66
	s_while : KW_WHILE '(' condicion ')' sentencia .  (19)

	$end  reduce 19
	'('  reduce 19
	'-'  reduce 19
	'{'  reduce 19
	'}'  reduce 19
	KW_IF  reduce 19
	KW_ELSE  reduce 19
	KW_WHILE  reduce 19
	KW_INT  reduce 19
	KW_WRITE  reduce 19
	KW_NEWLINE  reduce 19
	ID  reduce 19
	CONS  reduce 19


state 67
	sentencia : KW_WRITE '(' STRING ')' ';' .  (10)

	$end  reduce 10
	'('  reduce 10
	'-'  reduce 10
	'{'  reduce 10
	'}'  reduce 10
	KW_IF  reduce 10
	KW_ELSE  reduce 10
	KW_WHILE  reduce 10
	KW_INT  reduce 10
	KW_WRITE  reduce 10
	KW_NEWLINE  reduce 10
	ID  reduce 10
	CONS  reduce 10


state 68
	sentencia : KW_WRITE '(' expresion ')' ';' .  (9)

	$end  reduce 9
	'('  reduce 9
	'-'  reduce 9
	'{'  reduce 9
	'}'  reduce 9
	KW_IF  reduce 9
	KW_ELSE  reduce 9
	KW_WHILE  reduce 9
	KW_INT  reduce 9
	KW_WRITE  reduce 9
	KW_NEWLINE  reduce 9
	ID  reduce 9
	CONS  reduce 9


state 69
	sentencia : ID '=' KW_READ '(' ')' . ';'

	';'  shift 71


state 70
	s_if : KW_IF '(' condicion ')' sentencia KW_ELSE . sentencia

	'('  shift 1
	'-'  shift 2
	'{'  shift 3
	KW_IF  shift 4
	KW_WHILE  shift 5
	KW_INT  shift 6
	KW_WRITE  shift 7
	KW_NEWLINE  shift 8
	ID  shift 9
	CONS  shift 10

	sentencia goto 72
	s_if goto 13
	s_while goto 14
	expresion goto 15
	declaracion goto 16


state 71
	sentencia : ID '=' KW_READ '(' ')' ';' .  (8)

	$end  reduce 8
	'('  reduce 8
	'-'  reduce 8
	'{'  reduce 8
	'}'  reduce 8
	KW_IF  reduce 8
	KW_ELSE  reduce 8
	KW_WHILE  reduce 8
	KW_INT  reduce 8
	KW_WRITE  reduce 8
	KW_NEWLINE  reduce 8
	ID  reduce 8
	CONS  reduce 8


state 72
	s_if : KW_IF '(' condicion ')' sentencia KW_ELSE sentencia .  (18)

	$end  reduce 18
	'('  reduce 18
	'-'  reduce 18
	'{'  reduce 18
	'}'  reduce 18
	KW_IF  reduce 18
	KW_ELSE  reduce 18
	KW_WHILE  reduce 18
	KW_INT  reduce 18
	KW_WRITE  reduce 18
	KW_NEWLINE  reduce 18
	ID  reduce 18
	CONS  reduce 18


28 tokens, 9 nonterminals
31 grammar rules, 73 states
