// CompiladorDoc.h : interface of the CCompiladorDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPILADORDOC_H__FBDF110A_2F14_11D2_B3C8_000000000000__INCLUDED_)
#define AFX_COMPILADORDOC_H__FBDF110A_2F14_11D2_B3C8_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum COMPCODE {COMP_OK, COMP_ERROR, 
			PARSER_NOEJEC, TASM_NOEJEC, TLINK_NOEJEC, 
			PARSER_CONERROR, TASM_CONERROR, TLINK_CONERROR}; 

class CCompiladorDoc : public CRichEditDoc
{
protected: // create from serialization only
	CCompiladorDoc();
	DECLARE_DYNCREATE(CCompiladorDoc)

// Attributes
public:
	bool m_bLexBased;
	CString m_strExePath;

// Operations
public:
	COMPCODE Compile(CString& strOutputPath, CTimeSpan& timeSpan);
	DWORD EjecutarProceso(char* szProceso, char* szCmdLine, bool bShowWindow=true);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCompiladorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL
	virtual CRichEditCntrItem* CreateClientItem(REOBJECT* preo) const;

// Implementation
public:
	virtual ~CCompiladorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCompiladorDoc)
	afx_msg void OnLexbased();
	afx_msg void OnUpdateLexbased(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMPILADORDOC_H__FBDF110A_2F14_11D2_B3C8_000000000000__INCLUDED_)
