#include <lex.h>

#line 1 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"

	/* Anlaizador lexico TP1
	 * Integrantes: Yanina Manassa, Analia Jahnig, Diego Macrini
	*/                    
	extern void ErrorMessage(char* szMsg);
	#include "SharedTypes.h"
	#include "gramatica.h"
	
	extern "C" FILE *yyout;
	
	CSList<SYMBOL> symTable;
	CSList<char*>  stringList;
	int g_nLine = 0;
	int g_nErrors = 0;
	bool g_bDeclaracion = false;
	
	enum ERRORID {STRINGERROR, DBLDECL, UNKNOWNID};
	void OnError(ERRORID errorID);	

#line 24 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
#include "lexico.h"
#define INITIAL 0
/* repeated because of possible precompiled header */
#include <lex.h>

#ifndef YYTEXT_SIZE
#define YYTEXT_SIZE 100
#endif
#ifndef YYUNPUT_SIZE
#define YYUNPUT_SIZE YYTEXT_SIZE
#endif

/* yytext */
static char YYNEAR yysatext[(YYTEXT_SIZE) + 1];		/* extra char for \0 */
char *YYNEAR YYDCDECL yystext = yysatext;
char *YYNEAR YYDCDECL yytext = yysatext;
int YYNEAR YYDCDECL yystext_size = (YYTEXT_SIZE);
int YYNEAR YYDCDECL yytext_size = (YYTEXT_SIZE);

/* yystatebuf */
#if (YYTEXT_SIZE) != 0
static int YYNEAR yysastatebuf[(YYTEXT_SIZE)];
int *YYNEAR YYDCDECL yysstatebuf = yysastatebuf;
int *YYNEAR YYDCDECL yystatebuf = yysastatebuf;
#else
int *YYNEAR YYDCDECL yysstatebuf = NULL;
int *YYNEAR YYDCDECL yystatebuf = NULL;
#endif

/* yyunputbuf */
#if (YYUNPUT_SIZE) != 0
static int YYNEAR yysaunputbuf[(YYUNPUT_SIZE)];
int *YYNEAR YYDCDECL yysunputbufptr = yysaunputbuf;
int *YYNEAR YYDCDECL yyunputbufptr = yysaunputbuf;
#else
int *YYNEAR YYDCDECL yysunputbufptr = NULL;
int *YYNEAR YYDCDECL yyunputbufptr = NULL;
#endif
int YYNEAR YYDCDECL yysunput_size = (YYUNPUT_SIZE);
int YYNEAR YYDCDECL yyunput_size = (YYUNPUT_SIZE);

/* backwards compatability with lex */
#ifdef input
#ifdef YYPROTOTYPE
int YYCDECL yyinput(void)
#else
int YYCDECL yyinput()
#endif
{
	return input();
}
#else
#define input yyinput
#endif

#ifdef output
#ifdef YYPROTOTYPE
void YYCDECL yyoutput(int ch)
#else
void YYCDECL yyoutput(ch)
int ch;
#endif
{
	output(ch);
}
#else
#define output yyoutput
#endif

#ifdef unput
#ifdef YYPROTOTYPE
void YYCDECL yyunput(int ch)
#else
void YYCDECL yyunput(ch)
int ch;
#endif
{
	unput(ch);
}
#else
#define unput yyunput
#endif

#ifndef YYNBORLANDWARN
#ifdef __BORLANDC__
#pragma warn -rch		/* <warning: unreachable code> off */
#endif
#endif

#ifdef YYPROTOTYPE
int YYCDECL yylexaction(int action)
#else
int YYCDECL yylexaction(action)
int action;
#endif
{
	yyreturnflg = 1;
	switch (action) {
	case 1:
		{
#line 25 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
;
#line 127 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 2:
		{
#line 26 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
g_nLine++;
#line 134 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 3:
		{
#line 28 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_IF;
#line 141 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 4:
		{
#line 29 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_ELSE;
#line 148 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 5:
		{
#line 30 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_WHILE;
#line 155 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 6:
		{
#line 31 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 g_bDeclaracion = true; return KW_INT; 
#line 162 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 7:
		{
#line 33 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_READ;
#line 169 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 8:
		{
#line 34 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_WRITE;
#line 176 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 9:
		{
#line 35 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return KW_NEWLINE;
#line 183 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 10:
		{
#line 37 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = '>';   return COMP; 
#line 190 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 11:
		{
#line 38 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = '<';   return COMP; 
#line 197 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 12:
		{
#line 39 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = MENIG; return COMP; 
#line 204 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 13:
		{
#line 40 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = MAYIG; return COMP; 
#line 211 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 14:
		{
#line 41 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = IGIG;  return COMP; 
#line 218 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 15:
		{
#line 42 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nCompCode = DIST;  return COMP; 
#line 225 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 16:
		{
#line 44 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"

				if (yytext[yyleng - 1] != '"') OnError(STRINGERROR);
				else if (yytext[yyleng - 2] == '\\') {   // Caso de barra comillas
					yyless(yyleng - 1);
					yymore();
				}
				else {
					char* p = new char[yyleng - 2 + 1];	// Menos 2 comillas ms un \0
					memcpy(p, yytext + 1, yyleng - 2);	// Descarta las comillas
					p[yyleng - 2] = '\0';				// Se asigna nulo al final
					stringList.AddTail(p);
					yylval.pText = stringList.GetTailPos();
					return STRING;
				}
			
#line 246 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 17:
		{
#line 60 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
				
				SYMBOL sym;
				strcpy(sym.name, yytext);
				NODEPOS pos = symTable.Find(sym);
				if (pos) {		// Encontro el identificador
					yylval.pSymbol = pos;
					if (g_bDeclaracion) OnError(DBLDECL);
				}
				else {	// No lo encontro
					if (!g_bDeclaracion) OnError(UNKNOWNID);
					// Lo aade en ambos casos para seguir compilando
					symTable.AddTail(sym);
					yylval.pSymbol = symTable.GetTailPos();
				}
					
				return ID;
			
#line 269 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 18:
		{
#line 78 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
 yylval.nConst = atoi(yytext); return CONS; 
#line 276 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 19:
		{
#line 80 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
g_nLine++;
#line 283 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	case 20:
		{
#line 81 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"
return yytext[0];
#line 290 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
		}
		break;
	default:
		yyassert(0);
		break;
	}
	yyreturnflg = 0;
	return 0;
}

#ifndef YYNBORLANDWARN
#ifdef __BORLANDC__
#pragma warn .rch		/* <warning: unreachable code> to the old state */
#endif
#endif
#line 83 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.l"

void OnError(ERRORID errorID)
{
	g_nErrors++;
	fprintf(yyout, "ERROR: ");
	
	switch (errorID) {
		case STRINGERROR:
			fprintf(yyout, "falta cerrar comillas");
			break;
		case DBLDECL:
			fprintf(yyout, "doble declaracin de %s", yytext);
			break;
		case UNKNOWNID:
			fprintf(yyout, "identificador %s no declarado", yytext);
			break;
		default:
			fprintf(yyout, "desconocido");
		    break;			
	}
	
	fprintf(yyout, " en lnea %d\n", g_nLine);
}
#line 330 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\lexico.cpp"
YYCONST yymatch_t YYNEARFAR YYBASED_CODE YYDCDECL yymatch[] = {
	0
};
int YYNEAR YYDCDECL yytransitionmax = 208;
YYCONST yytransition_t YYNEARFAR YYBASED_CODE YYDCDECL yytransition[] = {
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 3, 1 },
	{ 18, 1 },
	{ 33, 15 },
	{ 34, 20 },
	{ 3, 3 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 3, 1 },
	{ 14, 1 },
	{ 15, 1 },
	{ 33, 15 },
	{ 3, 3 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 4, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 17, 1 },
	{ 20, 4 },
	{ 0, 0 },
	{ 12, 1 },
	{ 13, 1 },
	{ 11, 1 },
	{ 29, 12 },
	{ 30, 13 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 10, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 8, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 9, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 45, 40 },
	{ 31, 14 },
	{ 28, 11 },
	{ 0, 0 },
	{ 0, 0 },
	{ 0, 0 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 6, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 5, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 7, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 16, 1 },
	{ 21, 5 },
	{ 23, 6 },
	{ 24, 7 },
	{ 25, 8 },
	{ 26, 9 },
	{ 27, 10 },
	{ 35, 22 },
	{ 36, 23 },
	{ 22, 5 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 37, 24 },
	{ 38, 25 },
	{ 39, 26 },
	{ 40, 27 },
	{ 41, 36 },
	{ 42, 37 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 16, 16 },
	{ 43, 38 },
	{ 44, 39 },
	{ 46, 42 },
	{ 47, 44 },
	{ 48, 45 },
	{ 49, 48 },
	{ 50, 49 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 },
	{ 17, 17 }
};
YYCONST yystate_t YYNEARFAR YYBASED_CODE YYDCDECL yystate[] = {
	{ 0, 0, 0 },
	{ -19, 1, 0 },
	{ 1, 0, 0 },
	{ 0, 5, 1 },
	{ 0, 12, 20 },
	{ 16, 22, 17 },
	{ 16, 17, 17 },
	{ 16, 22, 17 },
	{ 16, 26, 17 },
	{ 16, 14, 17 },
	{ 16, 28, 17 },
	{ 0, 33, 10 },
	{ 0, 3, 11 },
	{ 0, 4, 20 },
	{ 0, 32, 20 },
	{ -32, 2, 20 },
	{ 0, 68, 17 },
	{ 0, 150, 18 },
	{ 0, 0, 19 },
	{ 0, 0, 20 },
	{ -20, 3, 0 },
	{ 16, 0, 3 },
	{ 16, 14, 17 },
	{ 16, 16, 17 },
	{ 16, 54, 17 },
	{ 16, 63, 17 },
	{ 16, 56, 17 },
	{ 16, 43, 17 },
	{ 0, 0, 13 },
	{ 0, 0, 12 },
	{ 0, 0, 14 },
	{ 0, 0, 15 },
	{ 15, 0, 0 },
	{ 0, 0, 16 },
	{ 0, 0, 2 },
	{ 16, 0, 6 },
	{ 16, 62, 17 },
	{ 16, 56, 17 },
	{ 16, 91, 17 },
	{ 16, 76, 17 },
	{ 16, 16, 17 },
	{ 16, 0, 4 },
	{ 16, 92, 17 },
	{ 16, 0, 7 },
	{ 16, 93, 17 },
	{ 16, 90, 17 },
	{ 16, 0, 5 },
	{ 16, 0, 8 },
	{ 16, 86, 17 },
	{ 16, 96, 17 },
	{ 16, 0, 9 }
};
YYCONST yybackup_t YYNEARFAR YYBASED_CODE YYDCDECL yybackup[] = {
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0
};
